EPGPFu = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "FuBarPlugin-2.0")
local EPGPFu, self = EPGPFu, EPGPFu

EPGPFu.hasIcon = true
EPGPFu.cannotDetachTooltip = true
EPGPFu.cannotAttachToMinimap = true
EPGPFu.defaultPosition = "RIGHT"
EPGPFu.title = "EPGP"

local L = AceLibrary("AceLocale-2.2"):new("FuBar_EPGPFu")

local Tablet = AceLibrary("Tablet-2.0")

function EPGPFu:OnInitialize() 
    self:RegisterEvent("PLAYER_ENTERING_WORLD") 
	self:RegisterEvent("RAID_ROSTER_UPDATE") 
	EPGP.RegisterCallback(EPGPFu, "StartRecurringAward")
	EPGP.RegisterCallback(EPGPFu, "StopRecurringAward")
	EPGP.RegisterCallback(EPGPFu, "RecurringAwardUpdate")
end 

function EPGPFu:PLAYER_ENTERING_WORLD()
	self:UpdateText("entering")
end

function EPGPFu:RAID_ROSTER_UPDATE()
	self:UpdateText("raid")
end

function EPGPFu:RecurringAwardUpdate(event_type, reason, amount, time_left)
    local fmt, val = SecondsToTimeAbbrev(time_left)
	local str = amount.." in "..fmt:format(val) or "running"
	self:UpdateText(str)
end

function EPGPFu:StartRecurringAward()
	self:UpdateText("running")
end

function EPGPFu:StopRecurringAward()
	self:UpdateText("stopped")
end

function EPGPFu:UpdateText(timeleft)
	self:SetText("EPGP")
	if EPGP and EPGP.db and UnitInRaid("player") then
		if EPGP:RunningRecurringEP() then
			self:SetText("EPGP : "..timeleft)
		else
			self:SetText("|cffff0000EPGP : stopped")
		end
	end
end

function EPGPFu:OnTooltipUpdate()
	Tablet:SetHint(L["Click to open EPGP window"])
end

function EPGPFu:OnClick()
	if EPGPFrame then
		ShowUIPanel(EPGPFrame)
	else
		Tablet:SetHint(L["Unable to find EPGP Addon loaded"])
	end
end